// ThisIsTheWorld.cpp

#include <iostream>

#include "seeGLUT.h"

#include "ThisIsTheWorld.h"
#include "LoadGame.h"  // uses position arrays for Objects in the World
#include "physicalWorld.h"  // keep player eye in sync with camera

// camera position (x, y, z) and direction of view
float xpos = 0, ypos = 0, zpos = 0, xrot = 0, yrot = 0;

// the eyes of the Player
void camera ()
{
	// look left and right
	glRotatef(xrot,1.0,0.0,0.0);
	// look up and down
	glRotatef(yrot,0.0,1.0,0.0);
	// contrain camera to the World area(volume)
	
	// move to current position
	keepLooking();
	glTranslated(-xpos,-ypos,-zpos);
}

// draw the Ground
void theGround()
{
	// draw a GL_QUAD_STRIP below in the first cube of the world space
	glPushMatrix();
	glTranslated( -positionx[10] * 10, 0, -positionz[10] * 10 );
	
	glBegin(GL_QUAD_STRIP);

	// Red
	glColor3f(   1.0f,  0.0f, 0.0f );
	glVertex3f(-50.0f, 0.0f, -50.0f);
	// Orange
	glColor3f(   1.0f,  0.5f,  0.0f );
	glVertex3f(50.0f, 0.0f, -50.0f);
	// Green
	glColor3f(   0.0f, 1.0f,  0.0f );
	glVertex3f(-50.0f, 0.0f, 50.0f);
	// Yellow
	glColor3f(   1.0f,  1.0f,  0.0f );
	glVertex3f(50.0f, 0.0f, 50.0f);
	// Blue
	// glColor3f(   0.0f,  0.0f,  1.0f);
	// Violet
	// glColor3f(   0.5f,  0.0f,  1.0f);

	glEnd();

	for (int i=0;i<9;i++)
	{
	glBegin(GL_LINES);
	//Black
	glColor3f(   0.0f,  0.0f,  0.0f);
	glVertex3f((40.0f - (i * 10)), 0.01f, -50.0f);
	glVertex3f((40.0f - (i * 10)), 0.01f, 50.0f);
	glEnd();
	glBegin(GL_LINES);
	//Black
	glColor3f(   0.0f,  0.0f,  0.0f);
	glVertex3f(-50.0f, 0.01f, (40.0f - (i * 10)));
	glVertex3f(50.0f, 0.01f, (40.0f - (i * 10)));
	glEnd();
	}

	glPopMatrix();
}

// fraw falling object
void theBall()
{
	glPushMatrix();
	glTranslated( positionx[11], positiony[11], positionz[11] );
	// Blue
	glColor3f(   0.0f,  0.0f,  1.0f);
	glutSolidCube( 2 ); //draw the cube
	glPopMatrix();

}

//draw the cubes that occupy The World
void cube ()
{
     for (int i=0;i<10;i++)
	{
		// draw a wireframe cube centered in the first cube of the world space
		glPushMatrix();
		glTranslated( -positionx[10] * 10, 0, -positionz[10] * 10 );
		glutWireCube( ((1 + i) * 10) ); //draw the cube
		glPopMatrix();

	

	//translate the cube that occupy the world space
	glPushMatrix();
	//draw the cube
	glTranslated(-positionx[i + 1] * 10, 1.0, -positionz[i + 1] * 10);

// Draw a Cube
	glBegin( GL_QUADS );
        // Top face
		// Green
        glColor3f(   0.0f, 1.0f,  0.0f );
		// Top-right of top face
        glVertex3f(  1.0f, 1.0f, -1.0f );
		// Top-left of top face
        glVertex3f( -1.0f, 1.0f, -1.0f );
		// Bottom-left of top face
        glVertex3f( -1.0f, 1.0f,  1.0f );
		// Bottom-right of top face
        glVertex3f(  1.0f, 1.0f,  1.0f );

        // Bottom face
		// Green
        glColor3f(   0.0f, 1.0f,  0.0f );
		// Top-right of bottom face
        glVertex3f(  1.0f, -1.0f, -1.0f );
		// Blue
        glColor3f(   0.0f,  0.0f,  1.0f);
		// Top-left of bottom face
        glVertex3f( -1.0f, -1.0f, -1.0f );
		// Green
        glColor3f(   0.0f, 1.0f,  0.0f );
		// Bottom-left of bottom face
        glVertex3f( -1.0f, -1.0f,  1.0f );
		// Yellow
        glColor3f(   1.0f,  1.0f,  0.0f );
		// Bottom-right of bottom face
        glVertex3f(  1.0f, -1.0f,  1.0f );

        // Front face
		// Red
        glColor3f(   1.0f,  0.0f, 0.0f );
		// Top-Right of front face
        glVertex3f(  1.0f,  1.0f, 1.0f );
		// Yellow
        glColor3f(   1.0f,  1.0f,  0.0f );
		// Top-left of front face
        glVertex3f( -1.0f,  1.0f, 1.0f );
		// Green
        glColor3f(   0.0f, 1.0f,  0.0f );
		// Bottom-left of front face
        glVertex3f( -1.0f, -1.0f, 1.0f );
		// Yellow
        glColor3f(   1.0f,  1.0f,  0.0f );
		// Bottom-right of front face
        glVertex3f(  1.0f, -1.0f, 1.0f );

        // Back face
		// Yellow
        glColor3f(   1.0f,  1.0f,  0.0f );
		// Bottom-Left of back face
        glVertex3f(  1.0f, -1.0f, -1.0f );
		// Bottom-Right of back face
        glVertex3f( -1.0f, -1.0f, -1.0f );
		// Top-Right of back face
        glVertex3f( -1.0f,  1.0f, -1.0f );
		// Top-Left of back face
        glVertex3f(  1.0f,  1.0f, -1.0f );

        // Left face
		// Blue
        glColor3f(   0.0f,  0.0f,  1.0f);
		// Top-Right of left face
        glVertex3f( -1.0f,  1.0f,  1.0f);
		// Top-Left of left face
        glVertex3f( -1.0f,  1.0f, -1.0f);
		// Bottom-Left of left face
        glVertex3f( -1.0f, -1.0f, -1.0f);
		// Bottom-Right of left face
        glVertex3f( -1.0f, -1.0f,  1.0f);

        // Right face
		// Red
        glColor3f(   1.0f,  0.0f, 0.0f );
		// Top-Right of left face
        glVertex3f(  1.0f,  1.0f,  1.0f);
		// Yellow
        glColor3f(   1.0f,  1.0f,  0.0f );
		// Top-Left of left face
        glVertex3f(  1.0f,  1.0f, -1.0f);
		// Green
        glColor3f(   0.0f, 1.0f,  0.0f );
		// Bottom-Left of left face
        glVertex3f(  1.0f, -1.0f, -1.0f);
		// Yellow
        glColor3f(   1.0f,  1.0f,  0.0f );
		// Bottom-Right of left face
        glVertex3f(  1.0f, -1.0f,  1.0f);
    glEnd();

	glPopMatrix();
	}
}

// this is the World called by void DisplayGL() in main.cpp
void ThisIsTheWorld ()
{
	// this is the World
	glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();

	// Translate World as seen by the Camera
	camera ();

	// let there be light
	glEnable ( GL_LIGHTING | GL_LIGHT0 );
	glShadeModel (GL_SMOOTH);

	// draw the Gorund
	theGround();

	// draw the falling object
	theBall();

	// render the cubes
	cube ();
}