// physicalWorld.h

#ifndef _PKYSICALWORLD_H_   // if x.h hasn't been included yet...
#define _PKYSICALWORLD_H_   // #define this so the compiler knows it has been included

// needed to initialize Bullect Physics World and Bullect Physics Objects
#include "btBulletDynamicsCommon.h"

#include "BulletDynamics\Character\btKinematicCharacterController.h"  // this is physical body of the Player in the bullet Physics World
#include "BulletCollision\CollisionDispatch\btGhostObject.h"

// called from main.cpp
void initBullet();

// called from UpdateTheWorld.cpp
void upDateBullet();  // runs the simulations in the Bullet World
void keepLooking();  // connects the players eyes to the GLUT camera

// called from KeyBoardKeys.cpp
void keepMoving( btVector3 &walkDirection );

// called from void cleanup( int errorCode, bool bExit ) in seeGLUT.cpp
void destroyBullet();

// need for the Bullet Physics World
void initBPWorld();
void destroyBPWorld();

// need for the Bullet Physics sObjects
void initBPObjects();
void destroyBPObjects();

#endif