// seeGLUT.cpp

#include "physicalWorld.h" // because void Cleanup( int errorCode, bool bExit ) calls destroyBullet();
#include "seeGLUT.h"

// global variables that will be used by GLUT to initialize the render window
// global error code to report the error when the application exists
int g_WindowWidth = 800;
int g_WindowHeight = 600;
int g_WindowHandle = 0;
int g_iErrorCode = 0;

// FUNCTION DEFINITIONS - - - //////////////////////

// setup OpenGL context and render window
void initGLUT ( int argc, char* argv[] )
{
	glutInit ( &argc, argv );
	glutSetOption ( GLUT_ACTION_ON_WINDOW_CLOSE, GLUT_ACTION_CONTINUE_EXECUTION );
	int iScreenWidth = glutGet ( GLUT_SCREEN_WIDTH );
	int iScreenHeight = glutGet ( GLUT_SCREEN_HEIGHT );
	glutInitDisplayMode ( GLUT_RGBA|GLUT_ALPHA|GLUT_DOUBLE|GLUT_DEPTH );
	// new GLUT window will be centered in Monitor
	glutInitWindowPosition ( ( iScreenWidth - g_WindowWidth ) / 2 , ( iScreenHeight - g_WindowHeight ) / 2 );
	glutInitWindowSize ( g_WindowWidth, g_WindowHeight );
	g_WindowHandle = glutCreateWindow ( "OpenFPS" );

	glEnable( GL_DEPTH_TEST );

	// register Call Back Functions with GLUT
	glutDisplayFunc(DisplayGL);
	glutIdleFunc(IdleGL);
	glutKeyboardFunc(KeyboardGL);
	glutMouseFunc(MouseGL);
	glutMotionFunc(ButMotionGL);
	glutPassiveMotionFunc(MotionGL);
	glutReshapeFunc(ReshapeGL);

	// center the Mouse Pointer in new GLUT window
	glutWarpPointer ( (g_WindowWidth / 2), (g_WindowHeight / 2));
}

// destroy the OpenGL context and render window
void Cleanup( int errorCode, bool bExit )
{
	// destroy all the Bullet Physics Objects and World
	destroyBullet();

    if ( g_WindowHandle != 0 )
    {
        glutDestroyWindow( g_WindowHandle );
        g_WindowHandle = 0;
    }

    if ( bExit )
    {
        exit( errorCode );
    }
}

