// seeGLUT.h

#ifndef _SEEGLUT_H_   // if x.h hasn't been included yet...
#define _SEEGLUT_H_   //   #define this so the compiler knows it has been included

#include <iostream>
#include <ctime>

#include <gl\glew.h>
#define FREEGLUT_STATIC
#define NDEBUG
#include <GL\freeglut.h>

// global variables that will be used by GLUT to initialize the render window
// global error code to report the error when the application exists
extern int g_WindowWidth;
extern int g_WindowHeight;
extern int g_WindowHandle;
extern int g_iErrorCode;

// this will create the OpenGL context and render window
void initGLUT ( int argc, char* argv[] );

// forward-declare the OpenGL GLUT callback functions
// these will be registered with GLUT in void InitGL( int argc, char* argv[] ) below
void DisplayGL();
void IdleGL();
void KeyboardGL( unsigned char c, int x, int y );
void MouseGL( int button, int state, int x, int y );
// passive mouse Function to detect mouse position on screen
void MotionGL( int x, int y );		// No Buttons Pressed
void ButMotionGL( int x, int y );	// One or more Buttons Pressed
void ReshapeGL( int w, int h );

// this will destroy the OpenGL context and render window
void Cleanup( int exitCode, bool bExit = true );


#endif